# type: perl delay.pl <trace file>

use List::MoreUtils 'first_index';

$infile=$ARGV[0];

#we compute how many bytes were transmitted during time interval specified by granularity parameter in seconds

open (DATA,"<$infile")
|| die "Cannot open $infile $!";
open (DATA2,"+>$meanpktdelay");

$tpstot=0;
$nbpkt=0;

@pktid=(0);
@startT=(0);

$k=0;
while (<DATA>) {
	@x = split(' ');

	if (($x[0] eq '+')&&($x[2]==2||$x[2]==3||$x[2]==4))
	{
		$startT[$k]=$x[1];
		$pktid[$k]=$x[11];
		$k=$k+1;
	}
	if (($x[0] eq 'r')&&($x[3]==1))
	{
		$index=first_index { $_ eq $x[11] } @pktid;
		$tpstot=$tpstot+($x[1]-$startT[$index]);
		$nbpkt=$nbpkt+1;
		splice @pktid, $index, 1;
		splice @startT, $index, 1;
		$k=$k-1;
	}
}

$meandelay=$tpstot/$nbpkt;
print stdout "$meandelay seconds\n";

close DATA;
exit(0);
