# type: perl delay_multi.pl <trace file>

use List::MoreUtils 'first_index';

$infile=$ARGV[0];

#we compute how many bytes were transmitted during time interval specified by granularity parameter in seconds

open (DATA,"<$infile")
|| die "Cannot open $infile $!";
open (DATA2,"+>$meanpktdelay");

$tpstot=0;
$nbpkt=0;
$tpstot2=0;
$nbpkt2=0;
$tpstot3=0;
$nbpkt3=0;

@pktid=(0);
@startT=(0);
@pktid2=(0);
@startT2=(0);
@pktid3=(0);
@startT3=(0);

$k=0;
$k2=0;
$k3=0;
while (<DATA>) {
	@x = split(' ');

	if (($x[0] eq '+')&&($x[2]==4)&&($x[7]==1))
	{
		$startT[$k]=$x[1];
		$pktid[$k]=$x[11];
		$k=$k+1;
	}
	if (($x[0] eq 'r')&&($x[3]==0)&&($x[7]==1))
	{
		$index=first_index { $_ eq $x[11] } @pktid;
		$tpstot=$tpstot+($x[1]-$startT[$index]);
		$nbpkt=$nbpkt+1;
		splice @pktid, $index, 1;
		splice @startT, $index, 1;
		$k=$k-1;
	}
########	
	if (($x[0] eq '+')&&($x[2]==5)&&($x[7]==2))
	{
		$startT2[$k2]=$x[1];
		$pktid2[$k2]=$x[11];
		$k2=$k2+1;
	}
	if (($x[0] eq 'r')&&($x[3]==0)&&($x[7]==2))
	{
		$index=first_index { $_ eq $x[11] } @pktid2;
		$tpstot2=$tpstot2+($x[1]-$startT2[$index]);
		$nbpkt2=$nbpkt2+1;
		splice @pktid2, $index, 1;
		splice @startT2, $index, 1;
		$k2=$k2-1;
	}
########
	if (($x[0] eq '+')&&($x[2]==6)&&($x[7]==3))
	{
		$startT3[$k3]=$x[1];
		$pktid3[$k3]=$x[11];
		$k3=$k3+1;
	}
	if (($x[0] eq 'r')&&($x[3]==0)&&($x[7]==3))
	{
		$index=first_index { $_ eq $x[11] } @pktid3;
		$tpstot3=$tpstot3+($x[1]-$startT3[$index]);
		$nbpkt3=$nbpkt3+1;
		splice @pktid3, $index, 1;
		splice @startT3, $index, 1;
		$k3=$k3-1;
	}
}

$meandelay=$tpstot/$nbpkt;
print stdout "mean delay flow 1: $meandelay seconds\n";
$meandelay2=$tpstot2/$nbpkt2;
print stdout "mean delay flow 2: $meandelay2 seconds\n";
$meandelay3=$tpstot3/$nbpkt3;
print stdout "mean delay flow 3: $meandelay3 seconds\n";

close DATA;
exit(0);
