# type: perl throughput.pl <trace file> <granularity> <file tput>

$infile=$ARGV[0];
$granularity=$ARGV[1];
$ftput=$ARGV[2];

#we compute how many bytes were transmitted during time interval specified by granularity parameter in seconds
$sum=0;
$clock=0;

open (DATA,"<$infile")
|| die "Cannot open $infile $!";
open (DATA2,"+>$ftput");

while (<DATA>) {
@x = split(' ');

#column 1 is time
if ($x[1]-$clock <= $granularity)
{
	#checking if the event corresponds to a reception
	if ($x[0] eq 'r')
	{
		#checking if the destination corresponds to 1st argument
		if ($x[3] eq 1)
		{
			#checking if the packet type is TCP
			if ($x[4] eq 'tcp')
			{
				$sum=$sum+$x[5];
			}
		}
	}
}
else
{	$throughput=$sum*8/$granularity;
	print DATA2 "$x[1] $throughput \n";
	$clock=$clock+$granularity;
	$sum=0;
}
}
$throughput=$sum*8/$granularity;
	print DATA2 "$x[1] $throughput \n";
	$clock=$clock+$granularity;
	$sum=0;close DATA;
close DATA;
close DATA2;
exit(0);

# POUR GNUPLOT: plot "win" using 1:2 title 'Connec 1' w lines 1, "win" using 1:3 title 'Connec 2' w lines 2
