# type: perl throughput.pl <trace file> <granularity> <file tput> <file lossrate>

$infile=$ARGV[0];
$granularity=$ARGV[1];
$ftput=$ARGV[2];
$floss=$ARGV[3];

#we compute how many bytes were transmitted during time interval specified by granularity parameter in seconds
$sum1=0;
$sum2=0;
$sum3=0;
$sumloss=0;
$clock=0;

open (DATA,"<$infile")
|| die "Cannot open $infile $!";
open (DATA2,"+>$ftput");
open (DATA3,"+>$floss");

while (<DATA>) {
@x = split(' ');

#column 1 is time
if ($x[1]-$clock <= $granularity)
{
	#checking if the event corresponds to a reception
	if ($x[0] eq 'r')
	{
		#checking if the destination corresponds to 1st argument
		if ($x[3] eq 3)
		{
			#checking if the packet type is TCP
			if ($x[4] eq 'tcp')
			{
				if ($x[7] eq 1)
				{
					$sum1=$sum1+$x[5];
				}
				elsif ($x[7] eq 2)
				{
					$sum2=$sum2+$x[5];
				}
				elsif ($x[7] eq 3)
				{
					$sum3=$sum3+$x[5];
				}
			}
			if ($x[4] eq 'cbr')
			{
				if ($x[7] eq 1)
				{
					$sum1=$sum1+$x[5];
				}
				elsif ($x[7] eq 2)
				{
					$sum2=$sum2+$x[5];
				}
				elsif ($x[7] eq 3)
				{
					$sum3=$sum3+$x[5];
				}
			}
		}
	}
	if ($x[0] eq 'd')
	{
		if ($x[2] eq 2)
		{
			$sumloss=$sumloss+1;
		}
	}
}
else
{	$throughput1=$sum1*8/$granularity;
	$throughput2=$sum2*8/$granularity;
	$throughput3=$sum3*8/$granularity;
	$lossrate=$sumloss/$granularity;
	print DATA2 "$x[1] $throughput1 $throughput2 $throughput3\n";
	print DATA3 "$x[1] $lossrate \n";
	$clock=$clock+$granularity;
	$sum1=0;
	$sum2=0;
	$sum3=0;
	$sumloss=0;
}
}
$throughput1=$sum1*8/$granularity;
$throughput2=$sum2*8/$granularity;
$throughput3=$sum3*8/$granularity;
$lossrate=$sumloss/$granularity;
print DATA2 "$x[1] $throughput1 $throughput2 $throughput3 \n";
print DATA3 "$x[1] $lossrate \n";
$clock=$clock+$granularity;
$sum1=0;
$sum2=0;
$sum3=0;
$sumloss=0;
close DATA;
close DATA2;
close DATA3;
exit(0);

# POUR GNUPLOT: plot "win" using 1:2 title 'Connec 1' w lines 1, "win" using 1:3 title 'Connec 2' w lines 2
